#include "mbed.h"
#include "tft.h"
#include "TouchScreen.h"

int color = WHITE;
Serial pc(USBTX, USBRX);

void drawCircles()
{
    Tft.drawCircle(100, 100, 30,YELLOW);
    Tft.drawCircle(100, 200, 40,CYAN);
    Tft.fillCircle(200, 100, 30,RED);
    Tft.fillCircle(200, 200, 30,BLUE);
};

void drawLines()
{
    Tft.drawLine(0,0,239,319,RED);
    Tft.drawVerticalLine(60,100,100,GREEN);
    Tft.drawHorizontalLine(30,60,150,BLUE);
}

void drawRectangle()
{
    Tft.drawRectangle(10, 3, 200,60,BLUE);
    Tft.fillRectangle(0, 80, 100,65,YELLOW);
    Tft.drawRectangle(30, 160, 60, 60,RED);
}

void drawShapes()
{
    for(int r=0;r<115;r=r+2)
   {
       Tft.drawCircle(119,160,r,rand());
   }
}

void drawText()
{
    Tft.drawString("Library for SEEED 2.8 v1.0",0,0,1,RED);
    Tft.drawString("Arduino TFT Touch Shield",0,12,1,BLUE);
    Tft.drawString("TJ Forshee",0,24,1,CYAN);
    Tft.drawString("Bluegrass Digital Inc.",0,36,1,WHITE);
    Tft.drawString("copyright Feb 2015",0,48,1,WHITE);
}

int main()
{
    pc.baud (9600);
    Tft.init();
    //Tft.setOrientation(0);
    Tft.fillRectangle(0,0,30,20,BLACK);
    Tft.fillRectangle(30,0,30,20,RED);
    Tft.fillRectangle(60,0,30,20,GREEN);
    Tft.fillRectangle(90,0,30,20,BLUE);
    Tft.fillRectangle(120,0,30,20,CYAN);
    Tft.fillRectangle(150,0,30,20,YELLOW);
    Tft.fillRectangle(180,0,30,20,WHITE);
    Tft.fillRectangle(210,0,30,20,GRAY1);
    TouchScreen tft_touch(A1, A3, A0, A2);
    //drawCircles();
    //drawLines();
    //drawRectangle();
    //drawShapes();
    //drawText();
    Point p;
    while (1)
    {
        p = tft_touch.getPoint();
        pc.printf("%i, %i, %i\n\r", p.x, p.y, p.z);
        if (p.z > tft_touch.pressureThreshold)
        {
            // Detect  paint brush color change
            if(p.y < 20)
            {
                if(p.x >= 0 && p.x < 30)
                {
                    color = BLACK;
                }
                if(p.x >= 30 && p.x < 60)
                {
                    color = RED;
                }
                if(p.x >= 60 && p.x < 90)
                {
                    color = GREEN;
                }
                if(p.x >= 90 && p.x < 110)
                {
                    color = BLUE;
                }
                if(p.x >= 120 && p.x < 150)
                {
                    color = CYAN;
                }
                if(p.x >= 150 && p.x < 180)
                {
                    color = YELLOW;
                }
                if(p.x >= 180 && p.x < 210)
                {
                    color = WHITE;
                }
                if(p.x >= 210 && p.x < 240)
                {
                    color = GRAY1;
                }
            }
            else
            {
                Tft.fillCircle(p.x,p.y,2,color);
            }
        }
    }
}

